function ring_handle = draw_ring(thickness, radius_of_centre, colour, transparency, x_shadow, y_shadow)

    % Each ring is considered to be a torus
    [x_t, y_t, z_t] = torus(thickness, 360, radius_of_centre);

    % With no z dimansion (i.e. it's a flat ring)
    z_t = z_t .* 0;

    % Work out where its intersection with the shadow is
    not_in_shadow = ~inpolygon(x_t, y_t, x_shadow, y_shadow);
    
    % And remove points in the shadow
    for i = 1:size(x_t, 1)
        for j = 1:size(x_t, 2)
            if not_in_shadow(i, j)
                x_t2(i, j) = x_t(i, j);
                y_t2(i, j) = y_t(i, j);
                z_t2(i, j) = z_t(i, j);
            else
                x_t2(i, j) = NaN;
                y_t2(i, j) = NaN;
                z_t2(i, j) = NaN;
            end
        end
    end
    
    % Now plot it
    ring_handle = surf(x_t2, y_t2, z_t2, ...
                       'FaceColor',    [colour colour colour], ...
                       'EdgeColor',    'none', ...
                       'FaceAlpha',    transparency);

end